/*
 *                **** FARMER.H ****
 *
 */

#ifndef FARMER_DEFS
#define FARMER_DEFS

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "linklist.h"
#include "prodlist.h"

/* locations of entities within state string */
#define ENT_FARMER	0
#define ENT_WOLF	1
#define ENT_GOAT	2
#define ENT_CABB	3
#define ENT_MAX		4

/* types of errors */
#define STATE_VALID	0
#define STATE_DUP	1
#define STATE_WOLF	2
#define STATE_CABB	3
#define STATE_GOAL	4



typedef struct farmer_struct {
	char states[5];	/* state of each entity */
	struct farmer_struct *parent;	/* parent of this structure */
	int move;		/* action of this move */
	int g;			/* length of path */
	int h;			/* heuristic evaluation */
	int f;			/* fitness function (g+g) */
} Farmer;

#include "farmer.pro"
#endif
